Source-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[src/trunk]: src/tests/sbin/ifconfig Add a basic test for enabling/disabling ...



details:   https://anonhg.NetBSD.org/src/rev/b81fd6a5df38
branches:  trunk
changeset: 935186:b81fd6a5df38
user:      jruoho <jruoho%NetBSD.org@localhost>
date:      Sat Jun 27 06:57:44 2020 +0000

description:
Add a basic test for enabling/disabling network interface capabilities.

diffstat:

 distrib/sets/lists/tests/mi           |    3 +-
 tests/sbin/ifconfig/Makefile          |    3 +-
 tests/sbin/ifconfig/t_capabilities.sh |  159 ++++++++++++++++++++++++++++++++++
 3 files changed, 163 insertions(+), 2 deletions(-)

diffs (196 lines):

diff -r 8afb1155f700 -r b81fd6a5df38 distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi       Sat Jun 27 06:50:00 2020 +0000
+++ b/distrib/sets/lists/tests/mi       Sat Jun 27 06:57:44 2020 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.856 2020/06/27 05:20:34 jruoho Exp $
+# $NetBSD: mi,v 1.857 2020/06/27 06:57:44 jruoho Exp $
 #
 # Note: don't delete entries from here - mark them as "obsolete" instead.
 #
@@ -3995,6 +3995,7 @@
 ./usr/tests/sbin/ifconfig/Atffile              tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/ifconfig/Kyuafile             tests-sbin-tests        compattestfile,atf,kyua
 ./usr/tests/sbin/ifconfig/t_bridge             tests-sbin-tests        compattestfile,atf
+./usr/tests/sbin/ifconfig/t_capabilities       tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/ifconfig/t_nonexistent                tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/ifconfig/t_repeated_scan      tests-sbin-tests        compattestfile,atf
 ./usr/tests/sbin/ifconfig/t_repeated_updown    tests-sbin-tests        compattestfile,atf
diff -r 8afb1155f700 -r b81fd6a5df38 tests/sbin/ifconfig/Makefile
--- a/tests/sbin/ifconfig/Makefile      Sat Jun 27 06:50:00 2020 +0000
+++ b/tests/sbin/ifconfig/Makefile      Sat Jun 27 06:57:44 2020 +0000
@@ -1,10 +1,11 @@
-# $NetBSD: Makefile,v 1.6 2020/06/27 05:07:07 jruoho Exp $
+# $NetBSD: Makefile,v 1.7 2020/06/27 06:57:44 jruoho Exp $
 
 .include <bsd.own.mk>
 
 TESTSDIR=      ${TESTSBASE}/sbin/ifconfig
 
 TESTS_SH=      t_bridge \
+               t_capabilities \
                t_nonexistent \
                t_repeated_scan \
                t_repeated_updown \
diff -r 8afb1155f700 -r b81fd6a5df38 tests/sbin/ifconfig/t_capabilities.sh
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/sbin/ifconfig/t_capabilities.sh     Sat Jun 27 06:57:44 2020 +0000
@@ -0,0 +1,159 @@
+# $NetBSD: t_capabilities.sh,v 1.1 2020/06/27 06:57:44 jruoho Exp $
+#
+# Copyright (c) 2020 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Jukka Ruohonen.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+setcap() {
+
+       echo "Request: $1 $2 ($3)"
+       ifconfig $1 $2
+
+       if [ $4 -eq 1 ]; then
+
+               if [ ! $? -eq 0 ]; then
+                       atf_fail "Failed to enable $3 for $1"
+               fi
+
+               if [ -z "$(ifconfig $1 | grep "enabled" | grep $3)" ]; then
+                       atf_fail "Failed to enable $3 for $1"
+               fi
+
+               echo "Request: $1 -$2 (-$3)"
+               ifconfig $1 -$2
+
+               if [ ! $? -eq 0 ]; then
+                       atf_fail "Failed to disable $3 for $1"
+               fi
+
+               if [ ! -z "$(ifconfig $1 | grep "enabled" | grep $3)" ]; then
+                       atf_fail "Failed to disable $3 for $1"
+               fi
+       fi
+}
+
+parsecap() {
+
+       i=$1
+       checkrv=$3
+       x=$(echo $2 | sed "s/.*<//" | sed "s/>//")
+
+       export IFS=","
+
+       for y in $x; do
+
+               z=""
+
+               if [ $y = "TSO4" ]; then
+                       z="tso4"
+               elif [ $y = "IP4CSUM_Rx" ]; then
+                       z="ip4csum-rx"
+               elif [ $y = "IP4CSUM_Tx" ]; then
+                       z="ip4csum-tx"
+               elif [ $y = "TCP4CSUM_Rx" ]; then
+                       z="tcp4csum-rx"
+               elif [ $y = "TCP4CSUM_Tx" ]; then
+                       z="tcp4csum-tx"
+               elif [ $y = "UDP4CSUM_Rx" ]; then
+                       z="udp4csum-rx"
+               elif [ $y = "UDP4CSUM_Tx" ]; then
+                       z="udp4csum-tx"
+               elif [ $y = "TCP6CSUM_Rx" ]; then
+                       z="tcp6csum-rx"
+               elif [ $y = "TCP6CSUM_Tx" ]; then
+                       z="tcp6csum-tx"
+               elif [ $y = "UDP6CSUM_Rx" ]; then
+                       z="udp6csum-rx"
+               elif [ $y = "UDP6CSUM_Tx" ]; then
+                       z="udp6csum-tx"
+               elif [ $y = "TSO6" ]; then
+                       z="tso6"
+               fi
+
+               if [ -z $z ]; then
+                       echo "Skipping unrecognized $y for $i"
+               else
+                       setcap $i $z $y $checkrv
+               fi
+       done
+
+       unset IFS
+}
+
+atf_test_case basic
+basic_head() {
+       atf_set "require.user" "root"
+       atf_set "descr" "Test setting interface capabilities"
+}
+
+basic_body() {
+
+       for i in $(ifconfig -l); do
+
+               c=$(ifconfig $i | grep "capabilities")
+
+               if [ -z "$c" ]; then
+                       echo "Skipping $i, no capabilities"
+                       continue
+               fi
+
+               if [ ! -z "$(echo $i | grep ixg)" ]; then
+                       echo "Skipping $i (PR kern/50933)"
+                       continue
+               fi
+
+               enabled=$(ifconfig $i | grep "enabled")
+
+               for l in $c; do
+
+                       if [ ! -z "$(echo $l | grep "ec_capabilities")" ]; then
+                               continue
+                       fi
+
+                       parsecap $i $l 1
+               done
+
+               if [ ! -z "$enabled" ]; then
+
+                       echo "Restoring capabilities for $i"
+
+                       for l in $enabled; do
+
+                               ec=$(echo $l | grep "ec_enabled")
+
+                               if [ ! -z "$ec" ]; then
+                                       continue
+                               fi
+
+                               parsecap $i $l 0
+                       done
+              fi
+       done
+}
+
+atf_init_test_cases() {
+       atf_add_test_case basic
+}



Home | Main Index | Thread Index | Old Index